*************************************************
***      ***
*************************************************

*** WinAPI-,   ini-
Declare GetPrivateProfileString IN Win32API AS GetINI ;
 String cAppName, ; 
 String cKeyName, ;
 String cDefault, ;
 String @ cReturnedString, ;
 Long nSize, ;
 String cFileName 
 
Local lcServerFile, lcLocalFile, lcUpdatePath, lcIniFile

lcUpdatePath = ReadFromINI("UpdatePath") &&   ini- ,   
lcLocalFile = ReadFromINI("FileName") &&   ,   

lcServerFile = Addbs(lcUpdatePath) + lcLocalFile &&   ( )   

lcCheckType = Upper(ReadFromINI("CheckType")) &&  

Local luServer, luLocal

DO Case
&&   Case -  ,        "  "

Case not File(lcSerVerFile) &&     
	luServer = .F.
	luLocal = .T.

Case not File(lcLocalFile) &&      
	luServer = .T.
	luLocal = .F.

Case lcCheckType = "VERSION" &&  
	luServer = GetVersion(lcServerFile)
	luLocal = GetVersion(lcLocalFile)

Case lcCheckType = "DATE" &&     
	luServer = fDate(lcServerFile, 1)
	luLocal = fDate(lcLocalFile, 1)

Case lcCheckType = "NOCHECK" &&    
	luServer = .T.
	luLocal = .F.

EndCase

If luLocal < luServer &&      ...
	On Error do ErrorHandler with Error()
	Copy File (lcServerFile) to (lcLocalFile)
	On Error
EndIf

Clear Dlls

If Not File(lcLocalFile) &&     ,      ...
	MessageBox("  " + lcLocalFile + "  !", 0 + 16, "")
	Quit
EndIf

&&    
&&   RUN,    DO
&&   chknew.exe   ,
&&      ,
&&      Set Safety
Run /N &lcLocalFile

***********************************************
***     ini- ***
***********************************************
Procedure ReadFromINI
Lparameters pcParameter
Local lcValue, lcIniFile

lcValue = Replicate(Chr(0), 255)
lcIniFile=FullPath( curdir() ) + 'ChkNew.ini'

GetINI( "Init", pcParameter, "", @lcValue, 255, lcIniFile )

Return StrTran( lcValue, chr(0) )

************************************************
***            ***
***      10   ***
************************************************
Procedure GetVersion
Lparameters pcFileName
Local lcVersion as Character, lcVer as Character, i as Integer

Local array laVersion[1]

AGetFileVersion(laVersion, pcFileName)

***    ...
If not Type("laVersion[4]") == "C"
	Return Space(10)
EndIf

lcVer = laVersion[4]

lnWordCount = GetWordCount(lcVer, ".")

lcVersion = ""
For i = 1 to lnWordCount
	lcVersion = lcVersion + "." + Padl( GetWordNum(lcVer, i, "."), 10, "0")
EndFor

***   
lcVersion = Substr(lcVersion, 2)

Return lcVersion

******************************************
***            ***
***      :) ***
******************************************
Procedure ErrorHandler
Lparameters pnErrorNumber, pcErrorMessage

DO Case
Case pnErrorNumber = 1102 && Cannot create file
	MessageBox("   !" ;
	+ Chr(13) + ",  ", ;
	16 + 0, " ")
	Quit

Otherwise
	Error pnErrorNumber

EndCase
